-- *************************************************
-- Desktop ikon kezels ki-be kapcsolshoz
-- Thanks to Garan for idea!
-- *************************************************
TDesktopIcon = class(Turbine.UI.Window);
function TDesktopIcon:Constructor(url, left, top, width, height)		
	Turbine.UI.Window.Constructor( self );	
	
	self.alert_status = 0;
	
--	local IconImageNormal = pluginRoot .. "resource/" .. IconImageStatus[self.alert_status];
	local IconImageMoving = pluginRoot .. "resource/plugin-icon-moving.tga";
	
	self.MoveX=-1;
	self.MoveY=0;
	self.Moving=false;
	self.moving_ico = false;
	
	local left=optionsO.icoLeft;
	local top=optionsO.icoTop;
	
	self:SetSize(32,32);
	self:Repaint();
	self:SetBlendMode(AlphaBlend);
	self:SetPosition( left, top );
	self:SetZOrder(self:GetZOrder()+1);
	self:SetVisible(true);
	
	self.MouseEnter = function() self:SetOpacity(1) end
	self.MouseLeave = function() 
		self:Repaint();
		self.moving_ico = false;
	end
	
	self.MouseClick = function(sender,args)
		if self.Moving then
			self.Moving=false;
			self.MoveX=-1;
		else
		if mainWindow:IsVisible() then
				debug("Ikon toggle off");
				mainWindow:Close();
--				optionsWindow:Close();
			else
				debug("Ikon toggle on");
--				eventWalletChange();
				mainWindow:SetVisible();
				mainWindow:Activate();	
			end
		end
	end
	self.MouseDown=function(sender,args)
		if self:IsControlKeyDown() then
			self.MoveX=args.X;
			self.MoveY=args.Y;
		end
		if self:IsControlKeyDown() then
			if 	self.moving_ico == false then
				self:SetBackground(IconImageMoving);
				self.moving_ico = true;
			end
		else
			if 	self.moving_ico == true then
				self:Repaint();
				self.moving_ico = false;
			end
		end
	end
	self.MouseUp=function(sender,args)
		self.MoveX=-1;
		self.MoveY=0;
		if (optionsO.icoLeft ~= self:GetLeft()) or (optionsO.icoTop ~= self:GetTop()) then
			optionsO.icoLeft = self:GetLeft();
			optionsO.icoTop = self:GetTop();
			optionsO:SaveState();		-- Ezt trni
			opIcoLeftSB:SetValue(optionsO.icoLeft);
			opIcoTopSB:SetValue(optionsO.icoTop);			
		end
	end
	self.MouseMove=function(sender,args)
		if self.MoveX~=-1 and (args.X~=self.MoveX or args.Y~= self.MoveY) then
			self.Moving=true;
			local newLeft=self:GetLeft()-(self.MoveX-args.X)
			local newTop=self:GetTop()-(self.MoveY-args.Y)
			if newLeft<0 then newLeft=0 end;
			if newLeft>(Turbine.UI.Display.GetWidth()-self:GetWidth()) then newLeft=Turbine.UI.Display.GetWidth()-self:GetWidth() end;
			if newTop<0 then newTop=0 end;
			if newTop>(Turbine.UI.Display.GetHeight()-self:GetHeight()) then newTop=Turbine.UI.Display.GetHeight()-self:GetHeight() end;
			self:SetPosition(newLeft,newTop);

		end
	end
	self.Update=function(sender,args)
		self.SetWantsUpdates(false); -- turn updates off... no need to waste machine cycles on this
	end
end
function TDesktopIcon:Repaint()
	local IconImageStatus = {[0]="plugin-icon.tga" , [1]="gearup-alert.tga", [2]="gearup-warning.tga"};
	self:SetBackground(pluginRoot .. "resource/" .. IconImageStatus[self.alert_status]);
	if self.alert_status == 0 then self:SetOpacity(.5);
	elseif self.alert_status == 1 then self:SetOpacity(.9);
	elseif self.alert_status == 2 then self:SetOpacity(.9);
	end
end;
